<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;

class Ocorrencia {

	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}

//Grupo
	public function buscaGrupoOcorre(){
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_GRUPO_OCORRENCIA);
	}

	public function criaGrupoOcorre($CDGRPOCOR, $DSGRPOCOR, $IDTIPGRP){
		$params = array(
			':CDGRPOCOR' => $CDGRPOCOR,
			':DSGRPOCOR' => $DSGRPOCOR,
			':IDTIPGRP' => $IDTIPGRP

		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::CRIA_GRUPO_OCORRENCIA, $params);
	}

	public function alteraGrupoOcorre($CDGRPOCOR, $DSGRPOCOR, $IDTIPGRP){
		$params = array(
			':CDGRPOCOR' => $CDGRPOCOR,
			':DSGRPOCOR' => $DSGRPOCOR,
			':IDTIPGRP' => $IDTIPGRP

		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::ALTERA_GRUPO_OCORRENCIA, $params);
	}
	public function excluiGrupoOcorre($CDGRPOCOR){
		$params = array(
			':CDGRPOCOR' => $CDGRPOCOR
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::EXCLUI_GRUPO_OCORRENCIA, $params);
	}
//Ocorrencia
	public function buscaOcorrenciasGrupo($CDGRPOCOR){
		$params = array(
			':CDGRPOCOR' => $CDGRPOCOR
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_OCORRENCIA_GRUPO_ESPECIFICO, $params);
	}
	public function criaObservacao($CDGRPOCOR, $CDOCORR, $DSOCORR,$IDSINAL,$NRCORSINAL){
		$params = array(
			':CDGRPOCOR' => $CDGRPOCOR,
			':CDOCORR' => $CDOCORR,
			':DSOCORR' => $DSOCORR,
			':IDSINAL' => $IDSINAL,
			':NRCORSINAL' => $NRCORSINAL

		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::CRIA_OCORRENCIA, $params);
	}

	public function editaObservacao($CDGRPOCOR, $CDOCORR, $DSOCORR,$IDSINAL,$NRCORSINAL){
		$params = array(
			':CDGRPOCOR' => $CDGRPOCOR,
			':CDOCORR' => $CDOCORR,
			':DSOCORR' => $DSOCORR,
			':IDSINAL' => $IDSINAL,
			':NRCORSINAL' => $NRCORSINAL
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::ALTERA_OCORRENCIA, $params);
	}
	public function excluiObservacao($CDGRPOCOR, $CDOCORR){
		$params = array(
			':CDGRPOCOR' => $CDGRPOCOR,
			':CDOCORR' => $CDOCORR
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::EXCLUI_OCORRENCIA, $params);
	}
//prodocorre
	public function buscaProdutosOcorrencia($CDGRPOCOR, $CDOCORR){
		$params = array(
			':CDGRPOCOR' => $CDGRPOCOR,
			':CDOCORR' => $CDOCORR
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_PRODUTO_OCORRENCIA, $params);
	}
	public function buscaProdutoOcorrenciaEspecifico($CDGRPOCOR, $CDOCORR, $CDPRODUTO){
		$params = array(
			':CDGRPOCOR' => $CDGRPOCOR,
			':CDOCORR' => $CDOCORR,
			':CDPRODUTO' => $CDPRODUTO
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_PRODUTO_OCORRENCIA_ESPECIFICO, $params);
	}
	public function criaProdutoOcorrencia($CDGRPOCOR, $CDOCORR, $CDPRODUTO, $NRTEMPOPROD){
		$params = array(
			':CDGRPOCOR' => $CDGRPOCOR,
			':CDOCORR' => $CDOCORR,
			':CDPRODUTO' => $CDPRODUTO,
			':NRTEMPOPROD' => $NRTEMPOPROD
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::CRIA_PRODUTO_OCORRENCIA, $params);
	}
	public function editaProdutoOcorrencia($CDGRPOCOR, $CDOCORR, $CDPRODUTO, $NRTEMPOPROD){
		$params = array(
			':CDGRPOCOR' => $CDGRPOCOR,
			':CDOCORR' => $CDOCORR,
			':CDPRODUTO' => $CDPRODUTO,
			':NRTEMPOPROD' => $NRTEMPOPROD
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::ALTERA_PRODUTO_OCORRENCIA, $params);
	}
	public function excluiProdutoOcorrencia($CDGRPOCOR, $CDOCORR, $CDPRODUTO){
		$params = array(
			':CDGRPOCOR' => $CDGRPOCOR,
			':CDOCORR' => $CDOCORR,
			':CDPRODUTO' => $CDPRODUTO
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::EXCLUI_PRODUTO_OCORRENCIA, $params);
	}
//setorprodobs
	public function adicionaObservacaoProdutoSetor($CDPRODUTO, $CDSETOR, $CDGRPOCOR, $CDOCORR, $NRTEMPOPROD){
		$params = array(
			':CDPRODUTO' => $CDPRODUTO,
			':CDSETOR' => $CDSETOR,
			':CDGRPOCOR' => $CDGRPOCOR,
			':CDOCORR' => $CDOCORR,
			':NRTEMPOPROD' => $NRTEMPOPROD
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::ADICIONA_OBSERVACAO_PRODUTO_SETOR, $params);
	}

	public function buscaObservacaoProdutoSetor($CDPRODUTO, $CDSETOR){
		$params = array(
			':CDPRODUTO' => $CDPRODUTO,
			':CDSETOR' => $CDSETOR
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_OBSERVACAO_PRODUTO_SETOR, $params);
	}

	public function buscaObservacaoProdutoSetorRow($CDPRODUTO, $CDSETOR, $CDOCORR){
		$params = array(
			':CDPRODUTO' => $CDPRODUTO,
			':CDSETOR'   => $CDSETOR,
			':CDOCORR'   => $CDOCORR
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_OBSERVACAO_PRODUTO_SETOR_ROW, $params);
	}

	public function excluiObservacaoProdutoSetor($CDPRODUTO, $CDSETOR, $CDGRPOCOR, $CDOCORR){
		$params = array(
			':CDPRODUTO' => $CDPRODUTO,
			':CDSETOR' => $CDSETOR,
			':CDGRPOCOR' => $CDGRPOCOR,
			':CDOCORR' => $CDOCORR
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::EXCLUI_OBSERVACAO_PRODUTO_SETOR, $params);
	}

	public function validaObsevacao($CDPRODUTO, $CDSETOR, $CDGRPOCOR, $CDOCORR){
		$params = array(
			':CDPRODUTO' => $CDPRODUTO,
			':CDSETOR' => $CDSETOR,
			':CDGRPOCOR' => $CDGRPOCOR,
			':CDOCORR' => $CDOCORR
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::VALIDA_OBSERVACAO, $params);
	}

	public function buscaDetalhesObservacao($CDPRODUTO, $CDSETOR, $CDOCORR, $CDGRPOCOR){
		$params = array(
			':CDPRODUTO' => $CDPRODUTO,
			':CDSETOR' => $CDSETOR,
			':CDGRPOCOR' => $CDGRPOCOR,
			':CDOCORR' => $CDOCORR
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_DETALHES_OBS, $params);
	}

	public function alteraDetalhesObservacao($CDPRODUTO, $CDSETOR, $CDOCORR, $CDGRPOCOR, $NRTEMPOPROD){
		$params = array(
			':CDPRODUTO' => $CDPRODUTO,
			':CDSETOR' => $CDSETOR,
			':CDGRPOCOR' => $CDGRPOCOR,
			':CDOCORR' => $CDOCORR,
			':NRTEMPOPROD' => $NRTEMPOPROD
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::ALTERA_DETALHES_OBS, $params);
	}

	public function	getcdocor($CDGRPOCOR){
		$params = array(':CDGRPOCOR' => $CDGRPOCOR);
		$CDOCORR = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_PRODOCOR_SEQ, $params);
		if (empty($CDOCORR)){
			return '01';
		}else{
			return str_pad($CDOCORR[0]['CDOCORR'], 2, '0', STR_PAD_LEFT);
		}
		return str_pad($CDOCORR[0]['CDOCORR'], 2, '0', STR_PAD_LEFT);
	}
}