<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelatoriosTabelaPrecoService {

	protected $entityManager; 
	
	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;

    }

	public function buscaDados($cdfilial, $cdloja, $produtoinicial, $produtofinal, $dtinivig, $cdtabprec, $nrorg, $idrelatorio) {
    
	    $params = array(
         	":CDFILIAL" => $cdfilial,
         	":CDLOJA" => $cdloja,
         	":CDPRODINI" => $produtoinicial,
         	":CDPRODFIN" => $produtofinal,
         	":DTINIVGPREC" => substr($dtinivig,0,10),
         	":CDTABEPREC" => $cdtabprec,
         	":NRORG" => $nrorg
 		);
 		ini_set('memory_limit', '3G');
        
 		switch($idrelatorio){
            case 0:
 				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_CONFIG_TERMINAL_CAIXA, $params);
		        return $response;
		    break;

			case 1:
				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_PRODUTOS_PENDENCIAS_IMPOSTOS, $params);
				return $response;
			break;
 		}

	}

	const BUSCA_REL_CONFIG_TERMINAL_CAIXA = "
            SELECT GRUPO.CDFILIAL, GRUPO.NMFILIAL, GRUPO.CDLOJA, GRUPO.NMLOJA, GRUPO.NRCONFTELA, GRUPO.NMCONFTELA,
               GRUPO.NMGRUPO, I.IDTPBUTONAUX, I.NRPGCONFTELA, I.NRBUTTONAUX, I.CDIDENTBUTON CDARVPROD,
               DSBUTTON DSBOTAOPROD, I.NRBUTTON, P.NMPRODUTO, IP.VRPRECITEM, 
               GRUPO.CDFILIAL AS PRIMCHAVE, I.CDATAPRODITM,
               GRUPO.CDFILIAL || GRUPO.CDLOJA AS SEGCHAVE,
               GRUPO.CDFILIAL || GRUPO.CDLOJA || GRUPO.NRCONFTELA AS TERCHAVE,
               GRUPO.CDFILIAL || GRUPO.CDLOJA || GRUPO.NRCONFTELA || I.NRBUTTONAUX AS QUACHAVE,
               I.NRORG
          FROM (SELECT DISTINCT I.CDFILIAL, F.NMFILIAL, C.CDLOJA, L.NMLOJA,
                                I.NRCONFTELA, C.NMCONFTELA, I.IDTPBUTTON, I.NRPGCONFTELA, DSBUTTON NMGRUPO,
                                I.NRBUTTON NRBOTAOGRUPO
                  FROM ITMENUCONFTE I, CONFTELA C, FILIAL F, LOJA L
                 WHERE I.CDFILIAL = C.CDFILIAL
                   AND I.NRCONFTELA = C.NRCONFTELA
                   AND C.CDFILIAL = F.CDFILIAL
                   AND C.CDLOJA = L.CDLOJA
                   AND F.CDFILIAL = :CDFILIAL
                   AND L.CDLOJA   = :CDLOJA
                   AND L.CDFILIAL = F.CDFILIAL
                   AND I.IDTPBUTTON = '2') GRUPO, ITMENUCONFTE I, CONFTELA C, PRODUTO P, TABEVEND TV, ITEMPRECO IP, TABEPREC TP 
         WHERE GRUPO.CDFILIAL = I.CDFILIAL
           AND GRUPO.NRCONFTELA = I.NRCONFTELA
           AND GRUPO.NRCONFTELA = C.NRCONFTELA
           AND GRUPO.CDLOJA = C.CDLOJA
           AND GRUPO.CDFILIAL = C.CDFILIAL
           AND I.IDTPBUTONAUX = GRUPO.IDTPBUTTON
           AND I.NRBUTTONAUX  = GRUPO.NRBOTAOGRUPO
           AND I.NRPGCONFTAUX = GRUPO.NRPGCONFTELA
           AND I.CDIDENTBUTON = P.CDPRODUTO
           AND I.IDTPBUTTON   = '1'
           AND (GRUPO.CDFILIAL = TV.CDFILIAL)
           AND (GRUPO.CDFILIAL = IP.CDFILIAL)
           AND (IP.CDPRODUTO   = P.CDPRODUTO)
           AND (TV.CDTABEPREC  = IP.CDTABEPREC)
           AND (TP.CDFILIAL    = TV.CDFILIAL  )
           AND (TP.CDTABEPREC  = TV.CDTABEPREC)
           AND (IP.CDTABEPREC  = :CDTABEPREC)  
           AND (IP.DTINIVGPREC = :DTINIVGPREC) 
           AND (TV.DTINIVGPREC  = IP.DTINIVGPREC)
           AND ((P.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIN) OR (:CDPRODINI = 'T'))
           AND (I.NRORG = :NRORG)
         ORDER BY GRUPO.CDFILIAL, GRUPO.CDLOJA, GRUPO.NRCONFTELA, GRUPO.NRPGCONFTELA, GRUPO.NRBOTAOGRUPO, I.NRPGCONFTELA, I.NRBUTTONAUX, I.NRBUTTON
    ";

    const BUSCA_REL_PRODUTOS_PENDENCIAS_IMPOSTOS = "
        SELECT CDFILIAL, NMFILIAL, CDTABEPREC, NMTABEPREC,
           NMPRODUTO, CDARVPROD, CDIMPOSTO AS CODIMPOSTO, VRPEALIMPFIS, 
           CDCFOPPFIS, CDCSTICMS, CDCSTPISCOF, VRALIQPIS,
           VRALIQCOFINS, CDCLASFISC, CDCEST
         FROM (SELECT DISTINCT
           F.CDFILIAL , F.NMFILIAL , T.CDTABEPREC, TP.NMTABEPREC,
           P.NMPRODUTO, P.CDARVPROD, A.CDIMPOSTO, A.VRPEALIMPFIS, 
           A.CDCFOPPFIS,A.CDCSTICMS,A.CDCSTPISCOF,A.VRALIQPIS,
           A.VRALIQCOFINS,P.CDCLASFISC,NVL(A.CDCEST,P.CDCEST) AS CDCEST
        FROM
           TABEVEND T, ITEMPRECO I, FILIAL F, PRODUTO P, TABEPREC TP, ALIQIMPFIS A
        WHERE
           (F.CDFILIAL    = T.CDFILIAL  ) AND
           (F.CDFILIAL    = I.CDFILIAL  ) AND
           (I.CDPRODUTO   = P.CDPRODUTO ) AND
           (T.CDTABEPREC  = I.CDTABEPREC) AND
           (TP.CDFILIAL   = T.CDFILIAL  ) AND
           (TP.CDTABEPREC = T.CDTABEPREC) AND
           (I.CDPRODUTO   = A.CDPRODUTO(+)) AND
           (I.CDFILIAL    = A.CDFILIAL(+))  AND
           (I.CDFILIAL    = :CDFILIAL )   AND
           (I.CDTABEPREC  = :CDTABEPREC)  AND
           (I.DTINIVGPREC = :DTINIVGPREC) AND
           (T.DTINIVGPREC = I.DTINIVGPREC)  AND
           (I.VRPRECITEM > 0)               AND
           ((P.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIN) OR (:CDPRODINI = 'T'))
        ORDER BY
           CDFILIAL, CDTABEPREC, CDIMPOSTO, CDARVPROD)
        WHERE
        (CDIMPOSTO IS NULL) OR
        (VRPEALIMPFIS IS NULL) OR 
        (CDCFOPPFIS IS NULL) OR
        (CDCSTICMS IS NULL) OR
        (CDCSTPISCOF IS NULL) OR
        (VRALIQPIS IS NULL) OR
        (VRALIQCOFINS IS NULL) OR
        (CDCLASFISC IS NULL) OR
        (CDCEST IS NULL)
   ";
}  